Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2008)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2011)
@@ -1573,5 +1858,1113 @@
        
     END SUBROUTINE usm_calc_svf
-   
+
+
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Subroutine checks variables and assigns units.
+!> It is caaled out from subroutine check_parameters.
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_check_data_output( variable, unit )
+        
+        IMPLICIT NONE
+ 
+        CHARACTER (len=*),INTENT(IN)    ::  variable !:
+        CHARACTER (len=*),INTENT(OUT)   ::  unit     !:
+        
+        CHARACTER (len=20)              :: var
+
+        var = TRIM(variable)
+        IF ( var(1:11)=='usm_radnet_'  .OR.  var(1:13)=='usm_rad_insw_'  .OR.           &
+             var(1:13)=='usm_rad_inlw_'  .OR.  var(1:16)=='usm_rad_inswdir_'  .OR.      &
+             var(1:16)=='usm_rad_inswdif_'  .OR.  var(1:16)=='usm_rad_inswref_'  .OR.   &
+             var(1:16)=='usm_rad_inlwdif_'  .OR.  var(1:16)=='usm_rad_inlwref_'  .OR.   &
+             var(1:14)=='usm_rad_outsw_'  .OR.  var(1:14)=='usm_rad_outlw_'  .OR.       &
+             var(1:11)=='usm_rad_hf_'  .OR.                                             &
+             var(1:9) =='usm_wshf_'  .OR.  var(1:9)=='usm_wghf_' )  THEN
+            unit = 'W/m2'
+        ELSE IF ( var(1:10) =='usm_t_surf'  .OR.  var(1:10) =='usm_t_wall' )  THEN
+            unit = 'K'
+        ELSE IF ( var(1:9) =='usm_surfz'  .OR.  var(1:7) =='usm_svf'  .OR.              & 
+                  var(1:7) =='usm_dif'  .OR.  var(1:11) =='usm_surfcat'  .OR.           &
+                  var(1:11) =='usm_surfalb'  .OR.  var(1:12) =='usm_surfemis')  THEN
+            unit = '1'
+        ELSE IF ( plant_canopy  .AND.  var(1:7) =='usm_lad' )  THEN
+            unit = 'm2/m3'
+        ELSE IF ( plant_canopy  .AND.  var(1:14) == 'usm_canopy_khf' )  THEN
+            unit = 'K/s'
+        ELSE
+            unit = 'illegal'
+        ENDIF
+
+    END SUBROUTINE usm_check_data_output
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Check parameters routine for urban surface model
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_check_parameters
+    
+       USE control_parameters,                                                 &
+           ONLY:  bc_pt_b, bc_q_b, constant_flux_layer, large_scale_forcing,   &
+                  lsf_surf, topography
+
+!
+!--    Dirichlet boundary conditions are required as the surface fluxes are
+!--    calculated from the temperature/humidity gradients in the urban surface
+!--    model
+       IF ( bc_pt_b == 'neumann'   .OR.   bc_q_b == 'neumann' )  THEN
+          message_string = 'urban surface model requires setting of '//        &
+                           'bc_pt_b = "dirichlet" and '//                      &
+                           'bc_q_b  = "dirichlet"'
+          CALL message( 'check_parameters', 'PA0590', 1, 2, 0, 6, 0 )
+       ENDIF
+
+       IF ( .NOT.  constant_flux_layer )  THEN
+          message_string = 'urban surface model requires '//                   &
+                           'constant_flux_layer = .T.'
+          CALL message( 'check_parameters', 'PA0591', 1, 2, 0, 6, 0 )
+       ENDIF
+!        
+!--    Surface forcing has to be disabled for LSF in case of enabled 
+!--    urban surface module
+       IF ( large_scale_forcing )  THEN
+          lsf_surf = .FALSE.
+       ENDIF
+!
+!--    Topography
+       IF ( topography == 'flat' )  THEN
+          message_string = 'topography /= "flat" is required '//               &
+                           'when using the urban surface model'
+          CALL message( 'check_parameters', 'PA0592', 1, 2, 0, 6, 0 )
+       ENDIF
+
+
+    END SUBROUTINE usm_check_parameters
+
+
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Output of the 3D-arrays in netCDF and/or AVS format 
+!> for variables of urban_surface model.
+!> It resorts the urban surface module output quantities from surf style
+!> indexing into temporary 3D array with indices (i,j,k).
+!> It is called from subroutine data_output_3d.
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_data_output_3d( av, variable, found, local_pf, nzb_do, nzt_do )
+        
+        IMPLICIT NONE
+
+        INTEGER(iwp), INTENT(IN)       ::  av        !< 
+        CHARACTER (len=*), INTENT(IN)  ::  variable  !< 
+        INTEGER(iwp), INTENT(IN)       ::  nzb_do    !< lower limit of the data output (usually 0)
+        INTEGER(iwp), INTENT(IN)       ::  nzt_do    !< vertical upper limit of the data output (usually nz_do3d)
+        LOGICAL, INTENT(OUT)           ::  found     !< 
+        REAL(sp), DIMENSION(nxlg:nxrg,nysg:nyng,nzb_do:nzt_do) ::  local_pf   !< sp - it has to correspond to module data_output_3d
+        REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg)     ::  temp_pf    !< temp array for urban surface output procedure
+        
+        CHARACTER (len=20)                                     :: var, surfid
+        INTEGER(iwp), PARAMETER                                :: nd = 5
+        CHARACTER(len=6), DIMENSION(0:nd-1), PARAMETER         :: dirname = (/ '_roof ', '_south', '_north', '_west ', '_east ' /)
+        INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER             :: dirint = (/ iroof, isouth, inorth, iwest, ieast /)
+        INTEGER(iwp), DIMENSION(0:nd-1)                        :: dirstart
+        INTEGER(iwp), DIMENSION(0:nd-1)                        :: dirend
+        INTEGER(iwp)                                           :: ids,isurf,isvf,isurfs,isurflt
+        INTEGER(iwp)                                           :: is,js,ks,i,j,k,iwl,istat
+
+        dirstart = (/ startland, startwall, startwall, startwall, startwall /)
+        dirend = (/ endland, endwall, endwall, endwall, endwall /)
+
+        found = .TRUE.
+        temp_pf = -1._wp
+        
+        ids = -1
+        var = TRIM(variable)
+        DO i = 0, nd-1
+            k = len(TRIM(var))
+            j = len(TRIM(dirname(i)))
+            IF ( var(k-j+1:k) == dirname(i) )  THEN
+                ids = i
+                var = var(:k-j)
+                EXIT
+            ENDIF
+        ENDDO
+        IF ( ids == -1 )  THEN
+            var = TRIM(variable)
+        ENDIF
+        IF ( var(1:11) == 'usm_t_wall_'  .AND.  len(TRIM(var)) >= 12 )  THEN
+!--         wall layers
+            READ(var(12:12), '(I1)', iostat=istat ) iwl
+            IF ( istat == 0  .AND.  iwl >= nzb_wall  .AND.  iwl <= nzt_wall )  THEN
+                var = var(1:10)
+            ENDIF
+        ENDIF
+        IF ( (var(1:8) == 'usm_svf_'  .OR.  var(1:8) == 'usm_dif_')  .AND.  len(TRIM(var)) >= 13 )  THEN
+!--         svf values to particular surface
+            surfid = var(9:)
+            i = index(surfid,'_')
+            j = index(surfid(i+1:),'_')
+            READ(surfid(1:i-1),*, iostat=istat ) is
+            IF ( istat == 0 )  THEN
+                READ(surfid(i+1:i+j-1),*, iostat=istat ) js
+            ENDIF
+            IF ( istat == 0 )  THEN
+                READ(surfid(i+j+1:),*, iostat=istat ) ks
+            ENDIF
+            IF ( istat == 0 )  THEN
+                var = var(1:7)
+            ENDIF
+        ENDIF
+        
+        SELECT CASE ( TRIM(var) )
+
+          CASE ( 'usm_surfz' )
+!--           array of lw radiation falling to local surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == ids )  THEN
+                      IF ( surfl(id,isurf) == iroof )  THEN
+                          temp_pf(0,surfl(iy,isurf),surfl(ix,isurf)) =             &
+                                  max(temp_pf(0,surfl(iy,isurf),surfl(ix,isurf)),  &
+                                      REAL(surfl(iz,isurf),wp))
+                      ELSE
+                          temp_pf(0,surfl(iy,isurf),surfl(ix,isurf)) =             &
+                                  max(temp_pf(0,surfl(iy,isurf),surfl(ix,isurf)),  &
+                                      REAL(surfl(iz,isurf),wp)+1.0_wp)
+                      ENDIF
+                  ENDIF
+              ENDDO
+
+          CASE ( 'usm_surfcat' )
+!--           surface category
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surface_types(isurf)
+                 ENDIF
+              ENDDO
+              
+          CASE ( 'usm_surfalb' )
+!--           surface albedo
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = albedo_surf(isurf)
+                 ENDIF
+              ENDDO
+              
+          CASE ( 'usm_surfemis' )
+!--           surface albedo
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = emiss_surf(isurf)
+                 ENDIF
+              ENDDO
+              
+          CASE ( 'usm_svf', 'usm_dif' )
+!--           shape view factors or iradiance factors to selected surface
+              IF ( TRIM(var)=='usm_svf' )  THEN
+                  k = 1
+              ELSE
+                  k = 2
+              ENDIF
+              DO isvf = 1, nsvfl
+                  isurflt = svfsurf(1, isvf)
+                  isurfs = svfsurf(2, isvf)
+                             
+                  IF ( surf(ix,isurfs) == is  .AND.  surf(iy,isurfs) == js  .AND.       &
+                       surf(iz,isurfs) == ks  .AND.  surf(id,isurfs) == ids )  THEN
+  !--                 correct source surface
+                      temp_pf(surfl(iz,isurflt),surfl(iy,isurflt),surfl(ix,isurflt)) = svf(k,isvf)
+                  ENDIF
+              ENDDO
+
+          CASE ( 'usm_radnet' )
+!--           array of complete radiation balance
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = rad_net_l(isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = rad_net_av(isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+
+          CASE ( 'usm_rad_insw' )
+!--           array of sw radiation falling to surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinsw(isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinsw_av(isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+
+          CASE ( 'usm_rad_inlw' )
+!--           array of lw radiation falling to surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinlw(isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinlw_av(isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+
+          CASE ( 'usm_rad_inswdir' )
+!--           array of direct sw radiation falling to surface from sun
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinswdir(isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinswdir_av(isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+
+          CASE ( 'usm_rad_inswdif' )
+!--           array of difusion sw radiation falling to surface from sky and borders of the domain
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinswdif(isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinswdif_av(isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+
+          CASE ( 'usm_rad_inswref' )
+!--           array of sw radiation falling to surface from reflections
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = &
+                       surfinsw(isurf) - surfinswdir(isurf) - surfinswdif(isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinswref_av(isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+
+          CASE ( 'usm_rad_inlwdif' )
+!--           array of sw radiation falling to surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinlwdif(isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinlwdif_av(isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+
+          CASE ( 'usm_rad_inlwref' )
+!--           array of lw radiation falling to surface from reflections
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinlw(isurf) - surfinlwdif(isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinlwref_av(isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+
+          CASE ( 'usm_rad_outsw' )
+!--           array of sw radiation emitted from surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfoutsw(isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfoutsw_av(isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+
+          CASE ( 'usm_rad_outlw' )
+!--           array of lw radiation emitted from surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfoutlw(isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfoutlw_av(isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+
+          CASE ( 'usm_rad_hf' )
+!--           array of heat flux from radiation for surfaces after all reflections
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfhf(isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfhf_av(isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+
+          CASE ( 'usm_wshf' )
+!--           array of sensible heat flux from surfaces
+!--           horizontal surfaces
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = wshf_eb(isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = wshf_eb_av(isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+
+          CASE ( 'usm_wghf' )
+!--           array of heat flux from ground (land, wall, roof)
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = wghf_eb(isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = wghf_eb_av(isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+
+          CASE ( 'usm_t_surf' )
+!--           surface temperature for surfaces
+              DO isurf = max(startenergy,dirstart(ids)), min(endenergy,dirend(ids))
+                 IF ( surfl(id,isurf) == ids )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = t_surf(isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = t_surf_av(isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+              
+          CASE ( 'usm_t_wall' )
+!--           wall temperature for  iwl layer of walls and land
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = t_wall(iwl,isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = t_wall_av(iwl,isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+
+          CASE ( 'usm_lad' )
+!--           leaf area density
+              DO i = nxl, nxr
+                 DO j = nys, nyn
+                     DO k = nzb_s_inner(j,i), nzut
+                         temp_pf(k,j,i) = lad_s(k-nzb_s_inner(j,i),j,i)
+                     ENDDO
+                 ENDDO
+              ENDDO
+              
+          CASE ( 'usm_canopy_khf' )
+!--           canopy kinematic heat flux
+              DO i = nxl, nxr
+                 DO j = nys, nyn
+                     DO k = nzb_s_inner(j,i), nzut
+                         temp_pf(k,j,i) = pc_heating_rate(k-nzb_s_inner(j,i),j,i)
+                     ENDDO
+                 ENDDO
+              ENDDO
+             
+          CASE DEFAULT
+              found = .FALSE.
+              
+        END SELECT
+        
+!--     fill out array local_pf which is subsequently treated by data_output_3d
+        CALL exchange_horiz( temp_pf, nbgp )
+        DO j = nysg,nyng
+            DO i = nxlg,nxrg
+                DO k = nzb_do, nzt_do
+                    local_pf(i,j,k) = temp_pf(k,j,i)
+                ENDDO
+            ENDDO
+        ENDDO
+        
+    END SUBROUTINE usm_data_output_3d
+    
+
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Soubroutine defines appropriate grid for netcdf variables.
+!> It is called out from subroutine netcdf.
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_define_netcdf_grid( variable, found, grid_x, grid_y, grid_z )
+    
+        IMPLICIT NONE
+
+        CHARACTER (len=*), INTENT(IN)  ::  variable    !< 
+        LOGICAL, INTENT(OUT)           ::  found       !< 
+        CHARACTER (len=*), INTENT(OUT) ::  grid_x      !< 
+        CHARACTER (len=*), INTENT(OUT) ::  grid_y      !< 
+        CHARACTER (len=*), INTENT(OUT) ::  grid_z      !< 
+
+        CHARACTER (len=20)            :: var
+
+        var = TRIM(variable)
+        IF ( var(1:11)=='usm_radnet_'  .OR.  var(1:13) =='usm_rad_insw_'  .OR.            &
+             var(1:13) =='usm_rad_inlw_'  .OR.  var(1:16) =='usm_rad_inswdir_'  .OR.      &
+             var(1:16) =='usm_rad_inswdif_'  .OR.  var(1:16) =='usm_rad_inswref_'  .OR.   &
+             var(1:16) =='usm_rad_inlwdif_'  .OR.  var(1:16) =='usm_rad_inlwref_'  .OR.   &
+             var(1:14) =='usm_rad_outsw_'  .OR.  var(1:14) =='usm_rad_outlw_'  .OR.       &
+             var(1:11) =='usm_rad_hf_'  .OR.                                              &
+             var(1:9) == 'usm_wshf_'  .OR.  var(1:9)== 'usm_wghf_'  .OR.                  &
+             var(1:10) == 'usm_t_surf'  .OR.  var(1:10) == 'usm_t_wall'  .OR.             &
+             var(1:9) == 'usm_surfz'  .OR.  var(1:7) == 'usm_svf'  .OR.                   & 
+             var(1:7) =='usm_dif'  .OR.  var(1:11) =='usm_surfcat'  .OR.                  &
+             var(1:11) =='usm_surfalb'  .OR.  var(1:12) =='usm_surfemis'  .OR.            &
+             var(1:7) == 'usm_lad'  .OR.  var(1:14) == 'usm_canopy_khf' )  THEN
+
+            found = .TRUE.
+            grid_x = 'x'
+            grid_y = 'y'
+            grid_z = 'zu'
+        ELSE
+            found  = .FALSE.
+            grid_x = 'none'
+            grid_y = 'none'
+            grid_z = 'none'
+        ENDIF
+
+    END SUBROUTINE usm_define_netcdf_grid
+    
+    
+!------------------------------------------------------------------------------!
+!> Finds first model boundary crossed by a ray
+!------------------------------------------------------------------------------!
+    PURE SUBROUTINE usm_find_boundary_face(origin, uvect, bdycross)
+        IMPLICIT NONE
+        REAL(wp), DIMENSION(3), INTENT(in)      :: origin    !< ray origin
+        REAL(wp), DIMENSION(3), INTENT(in)      :: uvect     !< ray unit vector
+        INTEGER(iwp), DIMENSION(4), INTENT(out) :: bdycross  !< found boundary crossing (d, z, y, x)
+        REAL(wp), DIMENSION(3)                  :: crossdist !< crossing distance
+        INTEGER(iwp), DIMENSION(3)              :: bdyd      !< boundary direction
+        REAL(wp)                                :: bdydim    !< 
+        REAL(wp)                                :: dist      !< 
+        INTEGER(iwp)                            :: seldim    !< found fist crossing index
+        INTEGER(iwp)                            :: d         !< 
+
+        bdydim = nzut + .5_wp !< top boundary
+        bdyd(1) = isky
+        crossdist(1) = (bdydim - origin(1)) / uvect(1)
+
+        IF ( uvect(2) >= 0._wp )  THEN
+            bdydim = ny + .5_wp !< north global boundary
+            bdyd(2) = inorthb
+        ELSE
+            bdydim = -.5_wp !< south global boundary
+            bdyd(2) = isouthb
+        ENDIF
+        crossdist(2) = (bdydim - origin(2)) / uvect(2)
+
+        IF ( uvect(3) >= 0._wp )  THEN
+            bdydim = nx + .5_wp !< east global boundary
+            bdyd(3) = ieastb
+        ELSE
+            bdydim = -.5_wp !< west global boundary
+            bdyd(3) = iwestb
+        ENDIF
+        crossdist(3) = (bdydim - origin(3)) / uvect(3)
+
+        seldim = minloc(crossdist, 1)
+        dist = crossdist(seldim)
+        d = bdyd(seldim)
+
+        bdycross(1) = d
+        bdycross(2:4) = NINT( origin(:) + uvect(:)*dist &
+                        + .5_wp * (/ kdir(d), jdir(d), idir(d) /) )
+    END SUBROUTINE
+
+
+!------------------------------------------------------------------------------!
+!> Determines whether two faces are oriented towards each other
+!------------------------------------------------------------------------------!
+    PURE LOGICAL FUNCTION usm_facing(x, y, z, d, x2, y2, z2, d2)
+        IMPLICIT NONE
+        INTEGER(iwp),   INTENT(in)  :: x, y, z, d, x2, y2, z2, d2
+      
+        usm_facing = .FALSE.
+        IF ( d==iroof  .AND.  d2==iroof ) RETURN
+        IF ( d==isky  .AND.  d2==isky ) RETURN
+        IF ( (d==isouth  .OR.  d==inorthb)  .AND.  (d2==isouth.OR.d2==inorthb) ) RETURN
+        IF ( (d==inorth  .OR.  d==isouthb)  .AND.  (d2==inorth.OR.d2==isouthb) ) RETURN
+        IF ( (d==iwest  .OR.  d==ieastb)  .AND.  (d2==iwest.OR.d2==ieastb) ) RETURN
+        IF ( (d==ieast  .OR.  d==iwestb)  .AND.  (d2==ieast.OR.d2==iwestb) ) RETURN
+
+        SELECT CASE (d)
+            CASE (iroof)                   !< ground, roof
+                IF ( z2 < z ) RETURN
+            CASE (isky)                    !< sky
+                IF ( z2 > z ) RETURN
+            CASE (isouth, inorthb)         !< south facing
+                IF ( y2 > y ) RETURN
+            CASE (inorth, isouthb)         !< north facing
+                IF ( y2 < y ) RETURN
+            CASE (iwest, ieastb)           !< west facing
+                IF ( x2 > x ) RETURN
+            CASE (ieast, iwestb)           !< east facing
+                IF ( x2 < x ) RETURN
+        END SELECT
+
+        SELECT CASE (d2)
+            CASE (iroof)                   !< ground, roof
+                IF ( z < z2 ) RETURN
+            CASE (isky)                    !< sky
+                IF ( z > z2 ) RETURN
+            CASE (isouth, inorthb)         !< south facing
+                IF ( y > y2 ) RETURN
+            CASE (inorth, isouthb)         !< north facing
+                IF ( y < y2 ) RETURN
+            CASE (iwest, ieastb)           !< west facing
+                IF ( x > x2 ) RETURN
+            CASE (ieast, iwestb)           !< east facing
+                IF ( x < x2 ) RETURN
+            CASE (-1)
+                CONTINUE
+        END SELECT
+
+        usm_facing = .TRUE.
+        
+    END FUNCTION usm_facing
+    
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Initialization of the wall surface model
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_init_material_model
+
+        IMPLICIT NONE
+
+        INTEGER(iwp) ::  k, l            !< running indices
+        
+        CALL location_message( '    initialization of wall surface model', .TRUE. )
+       
+!--     Calculate wall grid spacings. 
+!--     Temperature is defined at the center of the wall layers,
+!--     whereas gradients/fluxes are defined at the edges (_stag)
+        DO l = nzb_wall, nzt_wall
+           zwn(l) = zwn_default(l)
+        ENDDO
+        
+!--     apply for all particular wall grids
+        DO l = startenergy, endenergy
+           zw(:,l) = zwn(:) * thickness_wall(l)
+           dz_wall(nzb_wall,l) = zw(nzb_wall,l)
+           DO k = nzb_wall+1, nzt_wall
+               dz_wall(k,l) = zw(k,l) - zw(k-1,l)
+           ENDDO
+           
+           dz_wall(nzt_wall+1,l) = dz_wall(nzt_wall,l)
+
+           DO k = nzb_wall, nzt_wall-1
+               dz_wall_stag(k,l) = 0.5 * (dz_wall(k+1,l) + dz_wall(k,l))
+           ENDDO
+           dz_wall_stag(nzt_wall,l) = dz_wall(nzt_wall,l)
+        ENDDO
+        
+        ddz_wall      = 1.0_wp / dz_wall
+        ddz_wall_stag = 1.0_wp / dz_wall_stag
+        
+        CALL location_message( '    wall structures filed out', .TRUE. )
+
+        CALL location_message( '    initialization of wall surface model finished', .TRUE. )
+
+    END SUBROUTINE usm_init_material_model
+
+ 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Initialization of the urban surface model
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_init_urban_surface
+    
+        IMPLICIT NONE
+
+        INTEGER(iwp) ::  i, j, k, l            !< running indices
+        REAL(wp)     ::  c, d, tin, exn
+        
+        CALL cpu_log( log_point_s(78), 'usm_init', 'start' )
+!--     surface forcing have to be disabled for LSF 
+!--     in case of enabled urban surface module
+        IF ( large_scale_forcing )  THEN
+            lsf_surf = .FALSE.
+        ENDIF
+       
+!--     init anthropogenic sources of heat
+        CALL usm_allocate_urban_surface()
+       
+!--     read the surface_types array somewhere
+        CALL usm_read_urban_surface_types()
+        
+!--     init material heat model
+        CALL usm_init_material_model()
+        
+        IF ( usm_anthropogenic_heat )  THEN
+!--         init anthropogenic sources of heat (from transportation for now)
+            CALL usm_read_anthropogenic_heat()
+        ENDIF
+        
+        IF ( read_svf_on_init )  THEN
+!--         read svf and svfsurf data from file
+            CALL location_message( '    Start reading SVF from file', .TRUE. )
+            CALL usm_read_svf_from_file()
+            CALL location_message( '    Reading SVF from file has finished', .TRUE. )
+        ELSE
+!--         calculate SFV and CSF
+            CALL location_message( '    Start calculation of SVF', .TRUE. )
+            CALL cpu_log( log_point_s(79), 'usm_calc_svf', 'start' )
+            CALL usm_calc_svf()
+            CALL cpu_log( log_point_s(79), 'usm_calc_svf', 'stop' )
+            CALL location_message( '    Calculation of SVF has finished', .TRUE. )
+        ENDIF
+
+        IF ( write_svf_on_init )  THEN
+!--         write svf and svfsurf data to file
+            CALL usm_write_svf_to_file()
+        ENDIF
+        
+        IF ( plant_canopy )  THEN
+!--         gridpcbl was only necessary for initialization
+            DEALLOCATE( gridpcbl )
+            IF ( .NOT.  ALLOCATED(pc_heating_rate) )  THEN
+!--             then pc_heating_rate is allocated in init_plant_canopy
+!--             in case of cthf /= 0 => we need to allocate it for our use here
+                ALLOCATE( pc_heating_rate(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+            ENDIF
+        ENDIF
+
+!--     Intitialization of the surface and wall/ground/roof temperature
+
+!--     Initialization for restart runs
+        IF ( TRIM( initializing_actions ) == 'read_restart_data' )  THEN
+
+!--         restore data from restart file
+            CALL usm_read_restart_data()
+        ELSE
+       
+!--         Calculate initial surface temperature
+            exn = ( surface_pressure / 1000.0_wp )**0.286_wp
+
+            DO l = startenergy, endenergy
+                k = surfl(iz,l)
+                j = surfl(iy,l)
+                i = surfl(ix,l)
+
+!--              Initial surface temperature set from pt of adjacent gridbox
+                t_surf(l) = pt(k,j,i) * exn
+            ENDDO
+      
+!--         initial values for t_wall
+!--         outer value is set to surface temperature
+!--         inner value is set to wall_inner_temperature
+!--         and profile is logaritmic (linear in nz)
+            DO l = startenergy, endenergy
+                IF ( isroof_surf(l) )  THEN
+                    tin = roof_inner_temperature
+                ELSE IF ( surf(id,l)==iroof )  THEN
+                    tin = soil_inner_temperature
+                ELSE
+                    tin = wall_inner_temperature
+                ENDIF
+                DO k = nzb_wall, nzt_wall+1
+                    c = REAL(k-nzb_wall,wp)/REAL(nzt_wall+1-nzb_wall,wp)
+                    t_wall(k,:) = (1.0_wp-c)*t_surf(:) + c*tin
+                ENDDO
+            ENDDO
+        ENDIF
+        
+!--    
+!--        Possibly DO user-defined actions (e.g. define heterogeneous wall surface)
+        CALL user_init_urban_surface
+
+!--     initialize prognostic values for the first timestep
+        t_surf_p = t_surf
+        t_wall_p = t_wall
+        
+!--     Adjust radiative fluxes for urban surface at model start
+        CALL usm_radiation
+        
+        CALL cpu_log( log_point_s(78), 'usm_init', 'stop' )
+        
+        
+    END SUBROUTINE usm_init_urban_surface
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!
+!> Wall model as part of the urban surface model. The model predicts wall
+!> temperature.
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_material_heat_model
+
+
+        IMPLICIT NONE
+
+        INTEGER(iwp) ::  i,j,k,l,kw                      !< running indices
+
+        REAL(wp), DIMENSION(nzb_wall:nzt_wall) :: wtend  !< tendency
+
+                                               
+        DO l = startenergy, endenergy
+!--         calculate frequently used parameters
+            k = surfl(iz,l)
+            j = surfl(iy,l)
+            i = surfl(ix,l)
+
+            !
+!--         prognostic equation for ground/wall/roof temperature t_wall
+            wtend(:) = 0.0_wp
+            wtend(nzb_wall) = (1.0_wp/rho_c_wall(nzb_wall,l)) *                     &
+                       ( lambda_h(nzb_wall,l) * ( t_wall(nzb_wall+1,l)              &
+                         - t_wall(nzb_wall,l) ) * ddz_wall(nzb_wall+1,l)            &
+                         + wghf_eb(l) ) * ddz_wall_stag(nzb_wall,l)
+            
+            DO  kw = nzb_wall+1, nzt_wall
+                wtend(kw) = (1.0_wp/rho_c_wall(kw,l))                               &
+                              * (   lambda_h(kw,l)                                  &
+                                 * ( t_wall(kw+1,l) - t_wall(kw,l) )                &
+                                 * ddz_wall(kw+1,l)                                 &
+                              - lambda_h(kw-1,l)                                    &
+                                 * ( t_wall(kw,l) - t_wall(kw-1,l) )                &
+                                 * ddz_wall(kw,l)                                   &
+                              ) * ddz_wall_stag(kw,l)
+            ENDDO
+
+            t_wall_p(nzb_wall:nzt_wall,l) = t_wall(nzb_wall:nzt_wall,l)             &
+                                             + dt_3d * ( tsc(2)                     &
+                                             * wtend(nzb_wall:nzt_wall) + tsc(3)    &
+                                             * tt_wall_m(nzb_wall:nzt_wall,l) )   
+            
+            !
+!--         calculate t_wall tendencies for the next Runge-Kutta step
+            IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                IF ( intermediate_timestep_count == 1 )  THEN
+                   DO  kw = nzb_wall, nzt_wall
+                      tt_wall_m(kw,l) = wtend(kw)
+                   ENDDO
+                ELSEIF ( intermediate_timestep_count <                              &
+                         intermediate_timestep_count_max )  THEN
+                    DO  kw = nzb_wall, nzt_wall
+                        tt_wall_m(kw,l) = -9.5625_wp * wtend(kw) + 5.3125_wp        &
+                                         * tt_wall_m(kw,l)
+                    ENDDO
+                ENDIF
+            ENDIF
+        ENDDO
+
+    END SUBROUTINE usm_material_heat_model
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> This subroutine calculates interaction of the solar radiation
+!> with urban surface and updates surface, roofs and walls heatfluxes.
+!> It also updates rad_sw_out and rad_lw_out.
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_radiation
+    
+        IMPLICIT NONE
+       
+        INTEGER(iwp)               :: i, j, k, kk, is, js, d, ku, refstep
+        INTEGER(iwp)               :: nzubl, nzutl, isurf, isurfsrc, isurf1, isvf, ipcgb
+        INTEGER(iwp), DIMENSION(4) :: bdycross
+        REAL(wp), DIMENSION(3,3)   :: mrot            !< grid rotation matrix (xyz)
+        REAL(wp), DIMENSION(3,0:9) :: vnorm           !< face direction normal vectors (xyz)
+        REAL(wp), DIMENSION(3)     :: sunorig         !< grid rotated solar direction unit vector (xyz)
+        REAL(wp), DIMENSION(3)     :: sunorig_grid    !< grid squashed solar direction unit vector (zyx)
+        REAL(wp), DIMENSION(0:9)   :: costheta        !< direct irradiance factor of solar angle
+        REAL(wp), DIMENSION(nzub:nzut) :: pchf_prep   !< precalculated factor for canopy temp tendency
+        REAL(wp), PARAMETER        :: alpha = 0._wp   !< grid rotation (TODO: add to namelist or remove)
+        REAL(wp)                   :: rx, ry, rz
+        REAL(wp)                   :: pc_box_area, pc_abs_frac, pc_abs_eff
+        INTEGER(iwp)               :: pc_box_dimshift !< transform for best accuracy
+        
+        
+        IF ( plant_canopy )  THEN
+            pchf_prep(:) = r_d * (hyp(nzub:nzut) / 100000.0_wp)**0.286_wp &
+                        / (cp * hyp(nzub:nzut) * dx*dy*dz) !< equals to 1 / (rho * c_p * Vbox * T)
+        ENDIF
+
+        sun_direction = .TRUE.
+        CALL calc_zenith  !< required also for diffusion radiation
+
+!--     prepare rotated normal vectors and irradiance factor
+        vnorm(1,:) = idir(:)
+        vnorm(2,:) = jdir(:)
+        vnorm(3,:) = kdir(:)
+        mrot(1, :) = (/ cos(alpha), -sin(alpha), 0._wp /)
+        mrot(2, :) = (/ sin(alpha),  cos(alpha), 0._wp /)
+        mrot(3, :) = (/ 0._wp,       0._wp,      1._wp /)
+        sunorig = (/ sun_dir_lon, sun_dir_lat, zenith(0) /)
+        sunorig = matmul(mrot, sunorig)
+        DO d = 0, 9
+            costheta(d) = dot_product(sunorig, vnorm(:,d))
+        ENDDO
+        
+        IF ( zenith(0) > 0 )  THEN
+!--         now we will "squash" the sunorig vector by grid box size in
+!--         each dimension, so that this new direction vector will allow us
+!--         to traverse the ray path within grid coordinates directly
+            sunorig_grid = (/ sunorig(3)/dz, sunorig(2)/dy, sunorig(1)/dx /)
+!--         sunorig_grid = sunorig_grid / norm2(sunorig_grid)
+            sunorig_grid = sunorig_grid / SQRT(SUM(sunorig_grid**2))
+
+            IF ( plant_canopy )  THEN
+!--            precompute effective box depth with prototype Leaf Area Density
+               pc_box_dimshift = maxloc(sunorig, 1) - 1
+               CALL usm_box_absorb(cshift((/dx,dy,dz/), pc_box_dimshift),      &
+                                   60, prototype_lad,                          &
+                                   cshift(sunorig, pc_box_dimshift),           &
+                                   pc_box_area, pc_abs_frac)
+               pc_box_area = pc_box_area * sunorig(pc_box_dimshift+1) / sunorig(3)
+               pc_abs_eff = log(1._wp - pc_abs_frac) / prototype_lad
+            ENDIF
+        ENDIF
+        
+!--     split diffusion and direct part of the solar downward radiation
+!--     comming from radiation model and store it in 2D arrays
+!--     rad_sw_in_diff, rad_sw_in_dir and rad_lw_in_diff
+        IF ( split_diffusion_radiation )  THEN
+            CALL usm_calc_diffusion_radiation
+        ELSE
+            rad_sw_in_diff = 0.0_wp
+            rad_sw_in_dir(:,:)  = rad_sw_in(0,:,:)
+            rad_lw_in_diff(:,:) = rad_lw_in(0,:,:)
+        ENDIF
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!--     First pass: direct + diffuse irradiance
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        surfinswdir   = 0._wp
+        surfinswdif   = 0._wp
+        surfinlwdif   = 0._wp
+        surfins   = 0._wp
+        surfinl   = 0._wp
+        surfoutsl    = 0._wp
+        surfoutll    = 0._wp
+        
+!--     Set up thermal radiation from surfaces
+!--     emiss_surf is defined only for surfaces for which energy balance is calculated
+        surfoutll(startenergy:endenergy) = emiss_surf(startenergy:endenergy) * sigma_sb   &
+                                           * t_surf(startenergy:endenergy)**4
+        
+#if defined( __parallel )
+!--     might be optimized and gather only values relevant for current processor
+        CALL MPI_AllGatherv(surfoutll, nenergy, MPI_REAL, &
+                            surfoutl, nsurfs, surfstart, MPI_REAL, comm2d, ierr)
+#else
+        surfoutl(:) = surfoutll(:)
+#endif
+        
+        isurf1 = -1   !< previous processed surface
+        DO isvf = 1, nsvfl
+            isurf = svfsurf(1, isvf)
+            k = surfl(iz, isurf)
+            j = surfl(iy, isurf)
+            i = surfl(ix, isurf)
+            isurfsrc = svfsurf(2, isvf)
+            IF ( zenith(0) > 0  .AND.  isurf /= isurf1 )  THEN
+!--             locate the virtual surface where the direct solar ray crosses domain boundary
+!--             (once per target surface)
+                d = surfl(id, isurf)
+                rz = REAL(k, wp) - 0.5_wp * kdir(d)
+                ry = REAL(j, wp) - 0.5_wp * jdir(d)
+                rx = REAL(i, wp) - 0.5_wp * idir(d)
+                
+                CALL usm_find_boundary_face( (/ rz, ry, rx /), sunorig_grid, bdycross)
+                
+                isurf1 = isurf
+            ENDIF
+
+            IF ( surf(id, isurfsrc) >= isky )  THEN
+!--             diffuse rad from boundary surfaces. Since it is a simply
+!--             calculated value, it is not assigned to surfref(s/l),
+!--             instead it is used directly here
+!--             we consider the radiation from the radiation model falling on surface
+!--             as the radiation falling on the top of urban layer into the place of the source surface
+!--             we consider it as a very reasonable simplification which allow as avoid
+!--             necessity of other global range arrays and some all to all mpi communication
+                surfinswdif(isurf) = surfinswdif(isurf) + rad_sw_in_diff(j,i) * svf(1,isvf) * svf(2,isvf)
+                                                                !< canopy shading is applied only to shortwave
+                surfinlwdif(isurf) = surfinlwdif(isurf) + rad_lw_in_diff(j,i) * svf(1,isvf)
+            ELSE
+!--             for surface-to-surface factors we calculate thermal radiation in 1st pass
+                surfinl(isurf) = surfinl(isurf) + svf(1,isvf) * surfoutl(isurfsrc)
+            ENDIF
+            
+            IF ( zenith(0) > 0  .AND.  all( surf(:, isurfsrc) == bdycross ) )  THEN
+!--             found svf between model boundary and the face => face isn't shaded
+                surfinswdir(isurf) = rad_sw_in_dir(j, i) &
+                    * costheta(surfl(id, isurf)) * svf(2,isvf) / zenith(0)
+
+            ENDIF
+        ENDDO
+
+        IF ( plant_canopy )  THEN
+        
+            pcbinsw(:) = 0._wp
+            pcbinlw(:) = 0._wp  !< will stay always 0 since we don't absorb lw anymore
+            !
+!--         pcsf first pass
+            isurf1 = -1  !< previous processed pcgb
+            DO isvf = nsvfl+1, nsvfcsfl
+                ipcgb = svfsurf(1, isvf)
+                i = pcbl(ix,ipcgb)
+                j = pcbl(iy,ipcgb)
+                k = pcbl(iz,ipcgb)
+                isurfsrc = svfsurf(2, isvf)
+
+                IF ( zenith(0) > 0  .AND.  ipcgb /= isurf1 )  THEN
+!--                 locate the virtual surface where the direct solar ray crosses domain boundary
+!--                 (once per target PC gridbox)
+                    rz = REAL(k, wp)
+                    ry = REAL(j, wp)
+                    rx = REAL(i, wp)
+                    CALL usm_find_boundary_face( (/ rz, ry, rx /), &
+                        sunorig_grid, bdycross)
+
+                    isurf1 = ipcgb
+                ENDIF
+
+                IF ( surf(id, isurfsrc) >= isky )  THEN
+!--                 Diffuse rad from boundary surfaces. See comments for svf above.
+                    pcbinsw(ipcgb) = pcbinsw(ipcgb) + svf(1,isvf) * svf(2,isvf) * rad_sw_in_diff(j,i)
+!--                 canopy shading is applied only to shortwave, therefore no absorbtion for lw
+!--                 pcbinlw(ipcgb) = pcbinlw(ipcgb) + svf(1,isvf) * rad_lw_in_diff(j,i)
+                !ELSE
+!--                 Thermal radiation in 1st pass
+!--                 pcbinlw(ipcgb) = pcbinlw(ipcgb) + svf(1,isvf) * surfoutl(isurfsrc)
+                ENDIF
+
+                IF ( zenith(0) > 0  .AND.  all( surf(:, isurfsrc) == bdycross ) )  THEN
+!--                 found svf between model boundary and the pcgb => pcgb isn't shaded
+                    pc_abs_frac = 1._wp - exp(pc_abs_eff * lad_s(k,j,i))
+                    pcbinsw(ipcgb) = pcbinsw(ipcgb) &
+                        + rad_sw_in_dir(j, i) * pc_box_area * svf(2,isvf) * pc_abs_frac
+                ENDIF
+            ENDDO
+        ENDIF
+        surfins(startenergy:endenergy) = surfinswdir(startenergy:endenergy) + surfinswdif(startenergy:endenergy)
+        surfinl(startenergy:endenergy) = surfinl(startenergy:endenergy) + surfinlwdif(startenergy:endenergy)
+        surfinsw(:) = surfins(:)
+        surfinlw(:) = surfinl(:)
+        surfoutsw(:) = 0.0_wp
+        surfoutlw(:) = surfoutll(:)
+        surfhf(startenergy:endenergy) = surfinsw(startenergy:endenergy) + surfinlw(startenergy:endenergy) &
+                                      - surfoutsw(startenergy:endenergy) - surfoutlw(startenergy:endenergy)
+        
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!--     Next passes - reflections
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        DO refstep = 1, nrefsteps
+        
+            surfoutsl(startenergy:endenergy) = albedo_surf(startenergy:endenergy) * surfins(startenergy:endenergy)
+!--         for non-transparent surfaces, longwave albedo is 1 - emissivity
+            surfoutll(startenergy:endenergy) = (1._wp - emiss_surf(startenergy:endenergy)) * surfinl(startenergy:endenergy)
+
+#if defined( __parallel )
+            CALL MPI_AllGatherv(surfoutsl, nsurfl, MPI_REAL, &
+                surfouts, nsurfs, surfstart, MPI_REAL, comm2d, ierr)
+            CALL MPI_AllGatherv(surfoutll, nsurfl, MPI_REAL, &
+                surfoutl, nsurfs, surfstart, MPI_REAL, comm2d, ierr)
+#else
+            surfouts(:) = surfoutsl(:)
+            surfoutl(:) = surfoutll(:)
+#endif
+
+!--         reset for next pass input
+            surfins(:) = 0._wp
+            surfinl(:) = 0._wp
+            
+!--         reflected radiation
+            DO isvf = 1, nsvfl
+                isurf = svfsurf(1, isvf)
+                isurfsrc = svfsurf(2, isvf)
+
+!--             TODO: to remove if, use start+end for isvf
+                IF ( surf(id, isurfsrc) < isky )  THEN
+                    surfins(isurf) = surfins(isurf) + svf(1,isvf) * svf(2,isvf) * surfouts(isurfsrc)
+                    surfinl(isurf) = surfinl(isurf) + svf(1,isvf) * surfoutl(isurfsrc)
+                ENDIF
+            ENDDO
+
+!--         radiation absorbed by plant canopy
+            DO isvf = nsvfl+1, nsvfcsfl
+                ipcgb = svfsurf(1, isvf)
+                isurfsrc = svfsurf(2, isvf)
+
+                IF ( surf(id, isurfsrc) < isky )  THEN
+                    pcbinsw(ipcgb) = pcbinsw(ipcgb) + svf(1,isvf) * svf(2,isvf) * surfouts(isurfsrc)
+!--                 pcbinlw(ipcgb) = pcbinlw(ipcgb) + svf(1,isvf) * surfoutl(isurfsrc)
+                ENDIF
+            ENDDO
+            
+            surfinsw(:) = surfinsw(:)  + surfins(:)
+            surfinlw(:) = surfinlw(:)  + surfinl(:)
+            surfoutsw(startenergy:endenergy) = surfoutsw(startenergy:endenergy) + surfoutsl(startenergy:endenergy)
+            surfoutlw(startenergy:endenergy) = surfoutlw(startenergy:endenergy) + surfoutll(startenergy:endenergy)
+            surfhf(startenergy:endenergy) = surfinsw(startenergy:endenergy) + surfinlw(startenergy:endenergy) &
+                                          - surfoutsw(startenergy:endenergy) - surfoutlw(startenergy:endenergy)
+        
+        ENDDO
+
+!--     push heat flux absorbed by plant canopy to respective 3D arrays
+        IF ( plant_canopy )  THEN
+            pc_heating_rate(:,:,:) = 0._wp
+            DO ipcgb = 1, npcbl
+                j = pcbl(iy, ipcgb)
+                i = pcbl(ix, ipcgb)
+                k = pcbl(iz, ipcgb)
+                kk = k - nzb_s_inner(j,i)  !- lad arrays are defined flat
+                pc_heating_rate(kk, j, i) = (pcbinsw(ipcgb) + pcbinlw(ipcgb)) &
+                    * pchf_prep(k) * pt(k, j, i) !-- = dT/dt
+            ENDDO
+        ENDIF
+
+!--     return surface radiation to horizontal surfaces 
+!--     to rad_sw_in, rad_lw_in and rad_net for outputs
+        !!!!!!!!!!
+!--     we need the original radiation on urban top layer
+!--     for calculation of MRT so we can't do adjustment here for now
+        !!!!!!!!!!
+        !!!DO isurf = 1, nsurfl
+        !!!    i = surfl(ix,isurf)
+        !!!    j = surfl(iy,isurf)
+        !!!    k = surfl(iz,isurf)
+        !!!    d = surfl(id,isurf)
+        !!!    IF ( d==iroof )  THEN
+        !!!        rad_sw_in(:,j,i) = surfinsw(isurf)
+        !!!        rad_lw_in(:,j,i) = surfinlw(isurf)
+        !!!        rad_net(j,i) = rad_sw_in(k,j,i) - rad_sw_out(k,j,i) + rad_lw_in(k,j,i) - rad_lw_out(k,j,i)
+        !!!    ENDIF
+        !!!ENDDO
+
+    END SUBROUTINE usm_radiation
+
     
 !------------------------------------------------------------------------------!
